// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import type {NextApiRequest, NextApiResponse} from "next";
import client from "@/lib/mongodb";
import {withIronSessionApiRoute} from "iron-session/next";
import {sessionOptions} from "@/lib/session";
import {Group} from "@/interfaces/user";
import {v4} from "uuid";
import {updateExpiryDateOnGroup, getGroupsForUser} from "@/utils/groups.be";
import {uniq, uniqBy} from "lodash";

const db = client.db(process.env.MONGODB_DB);

export default withIronSessionApiRoute(handler, sessionOptions);

async function handler(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	if (req.method === "GET") await get(req, res);
	if (req.method === "POST") await post(req, res);
}

async function get(req: NextApiRequest, res: NextApiResponse) {
	const {admin, participant} = req.query as {
		admin: string;
		participant: string;
	};

	const adminGroups = await getGroupsForUser(admin, participant);
	const participants = uniq(adminGroups.flatMap((g) => g.participants));
	const groups = await Promise.all(participants.map(async (c) => await getGroupsForUser(c, participant)));
	return res.status(200).json([...adminGroups, ...uniqBy(groups.flat(), "id")]);
}

async function post(req: NextApiRequest, res: NextApiResponse) {
	const body = req.body as Group;

	await Promise.all(body.participants.map(async (p) => await updateExpiryDateOnGroup(p, body.admin)));

	const id = v4();
	await db.collection<Group>("groups").insertOne({
		id,
		name: body.name,
		admin: body.admin,
		participants: body.participants,
	});
	res.status(200).json({ok: true, id});
}
